;Filename: TLif.s
;Part: ADuC703x.
;Created: 12/04/2006
;Author: Eckart Hartmann of Analog Devices
;This file is in beta sampling.

;This software is supplied subject our standard software license agreement.
;A non-binding summary is as follows:
;"You may use the software in your own code at your own risk.
;" ADI inc disclaims any warranty or liability of its use".
;The full standard software license agreement is available on request and
; remains the binding agreement.

#include        "..\Fla\ADuC703xi.equ"

; TLif==========Handles T0 48 bit features.
; C Function prototype: int TLif(int iT, int i48Bit);
;iT:{T_T0,}
;i48Bit:{T_16Bit,T_48Bit}
; Description of Function: Sets T0 16 or 48 bit mode and
;   Reads T0 high 32 bits (T0VAL1).
; User interface:
;   Set iT to 0.
;   Set i48Bit to 1 for life timer mode and 0 for 16 bit mode.
;   Call TLif(iT, i48Bit).
;   Returns T0VAL1 in r0.
; Robustness:
;  Will have no effect if iT is not 0.
; Side effects: Corrupts r3.

                RSEG CODE
                MODULE TLif
                PUBLIC TLif
                CODE32

TLif:   cmp     r0,#0                   ;if(r0!=T0)
        moveq   r3,#0xff0000            ;r3 = Z_BASE
        orreq   r3,r3,#0xff000000
        ldreq   r2,[r3,#Z_T0CON]        ;r2 = T0CON;
        biceq   r2,r2,#0x10             ;Remove size.
        andeq   r1,r1,#1                ;Add new size.
        orreq   r2,r2,r1,LSL#4
        streq   r2,[r3,#Z_T0CON]        ;T0CON = r2;
        ldreq   r0,[r3,#Z_T0VAL1]       ;r0 = T0VAL1.
TLifR:  bx      lr

                 ENDMOD  TLif
                 END

